package cn.rankin.apiweb.service.download;

import cn.rankin.data.api.user.dto.DownloadInfoDTO;
import cn.rankin.data.api.user.entity.DownloadInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class DownloadInfoService {

    @Autowired
    private DownloadInfoClient downloadInfoClient;

    public DownloadInfo add(DownloadInfoDTO dto) {
        return downloadInfoClient.add(dto);
    }


    public List<DownloadInfo> findByUserId(String uid) {
        return downloadInfoClient.findByUserId(uid);
    }

    public DownloadInfo findByLessonUserId(String uid,String lessonId) {
        return downloadInfoClient.findByLessonUserId(uid,lessonId);
    }

    public DownloadInfo deleteByLessonUserId(String uid, String lessonId) {
        return downloadInfoClient.deleteByLessonUserId(uid,lessonId);
    }

    public DownloadInfo updateByLessonUserId(String uid, String lessonId) {
        return downloadInfoClient.updateByLessonUserId(uid,lessonId);
    }



}
